// which weapon to use, depending on the animation type 
#define WEAPONS_TO_USE	[[ "non",""], ["pst","VBS2_Browning_HiPower"], ["rfl","vbs2_au_f88c_iron_none"], ["lnr","vbs2_m72a6_LAW"]]


#include "\vbs2\headers\function_library.hpp"
#include "\vbs2\headers\dikCodes.hpp"
#include "defines.hpp"

if !(dialog) then {
	_ok = createDialog "DlgMoves";
} else {
	lbClear ListIdM;
};


if (KRON_ListModeSwitch) then {
	ctrlSetText [105,"Switch"]; 
} else {
	ctrlSetText [105,"Play"];
};
if (KRON_ListAccTime==1) then {
	ctrlSetText [106,"Normal"]; 
} else {
	ctrlSetText [106,"Slow-Mo"]; 
};


// load animation list
KRON_list = (_this select 3) select 0;
_filter = toLower ((_this select 3) select 1);
_file = format["anims_%1.sqf",KRON_list];
_nul = [] execVM _file;
waitUntil {scriptDone _nul};
{
	if (_filter in toLower(_x)) then {
		_index = lbAdd [ListIdM,_x];
	};
}forEach KRON_ListAnims;            
            
if (isNil 'KRON_ListIdx') then {KRON_ListIdx=0};
if (KRON_ListIdx>lbSize ListIdM) then {KRON_ListIdx=0};
lbSetCurSel [ListIdM, KRON_ListIdx+5];
lbSetCurSel [ListIdM, KRON_ListIdx];

KRON_ListRefresh=false;
while {ctrlVisible ListIdM} do {
	_indexold = lbCurSel ListIdM;
	waitUntil {(_indexold != lbCurSel ListIdM) || !ctrlVisible ListIdM || KRON_ListRefresh};
	_shiftPressed = ((isKeyPressed DIK_LSHIFT) || (isKeyPressed DIK_RSHIFT));
	KRON_ListRefresh=false;
	if !(_shiftPressed) then {
		soldier setPosASL KRON_OrgPos;
		soldier setDir KRON_OrgDir;
		soldier switchMove KRON_DefAnim;
		sleep 1;
	};
	_index = lbCurSel ListIdM;
	if (_index>=0) then {KRON_ListIdx=_index};
	KRON_ListMove = lbText [ListIdM, _index];
	if (KRON_ListMove!="") then {
		setAccTime KRON_ListAccTime;
		ctrlSetText [CaptIdM, KRON_ListMove];
		KRON_ListAnimCnt=0;
		_start=time;
		_length=0;
		// equip unit with appropriate weapon (or none), depending on start animation		
		_startAnim = KRON_ListMove;
		if ("_" in KRON_ListMove) then {
			_break=[KRON_ListMove,"_"] call fn_vbs_StrIndex;
			_startAnim = [KRON_ListMove,_break-1] call fn_vbs_StrLeft;
		};
		{
			_animType = _x select 0;
			_wpnType = _x select 1;
			if (_animType in _startAnim) exitWith {
				if !(_wpnType in weapons soldier) then {
					removeAllWeapons soldier;
					soldier addWeapon "Binocular";
					if (_wpnType != "") then {
						soldier addWeapon _wpnType;
						sleep 3;
					};
				};
			};
		}forEach WEAPONS_TO_USE;

		if (KRON_ListModeSwitch) then {
			soldier switchMove KRON_ListMove;
		} else {
			soldier playMove KRON_ListMove;
		};
		_animcnt=0;
		_lastcnt=0;
		_abort=false;
		waitUntil {
			_length = time-_start;
			_animcnt=_animcnt max KRON_ListAnimCnt;
			_done=(KRON_ListAnimCnt<_lastcnt);
			_abort=(KRON_ListIdx != lbCurSel ListIdM);
			//echo format["[K] %1, %2, %3, %4, %5",_lastcnt,KRON_ListAnimCnt,_length,_done,_abort];
			_lastcnt = KRON_ListAnimCnt;
			((animationState soldier==KRON_DefAnim) || (_done) || (_abort))
		};
		clearRadio;
		setAccTime 1;
		if (KRON_ListWarning) then {
			player sidechat "Be aware that the shown animation durations may not be reliable in some cases!";
			KRON_ListWarning=false;
		};

		if (_abort) then {
			soldier switchMove KRON_DefAnim;
			KRON_ListRefresh=true;
			player sidechat "animation aborted";
			sleep 1;
		} else {
			if ((KRON_ListAccTime==1) && (_length!=0)) then {
				player sidechat format["'%1': %2 sec.",KRON_ListMove,_length];
			};
		};
		sleep .1;
	};
};
